# tx.py - 22.01.2022
#
import time
from serial_over_ir import Serial_Over_Ir
    
# --- Einstellungen --------------------  

ir_pin    = 16    # Serielles Signal - moduliert
                  # activ high
baud      = 2400
ir_freq   = 38_000
STARTBYTE = 0xAA

tx = Serial_Over_Ir(ir_pin = ir_pin,
                    ir_freq = ir_freq,
                    baud = baud)
# ------------------------------------
msg_cnt = 100          # 100 Datensätze versenden

while msg_cnt:
    msg_cnt -= 1

    msg = bytearray((STARTBYTE, 0))  # Startbyte + Platzhalter für die Länge
    
    data = ("ABCDEabcde".encode())
    #data = bytearray((255,255,0,0,170,55,255))
    data = bytes([x for x in range(65, 127)])
    
    # Die Testdaten an das Bytearray anhängen
    for d in data:
        msg.append(d)
        
    # Die Länge des Datensatzes in das Byte 1 schreiben
    msg[1] = len(msg) + 1
    
    # Die Checksumme über den gesamten Datensatz bilden
    checksum = 0
    for i in msg:
        checksum += i
    # Die Checksumme auf 0xFF ergänzen, den dazu notwendigen Wert
    # als letztes Byte anhängen.
    # Der Empfänger sieht als korrekte Checksumme über den gesamten
    # Datensatz 0xFF, sonst liegt ein Fehler vor.
    msg.append(0xFF - checksum % 256)   
    
    #last = time.ticks_us()
    
    tx.send(msg)
    print(".", end = "")
        
    #now = time.ticks_us()

    #print("Time for tx_send(): {} ms".format(time.ticks_diff(now, last)/ 1000))

    time.sleep(.5)         # Warten bis die msg raus ist
    
tx.deactivate()
print("\ndone")
